-- by modelleicher
-- www.schwabenmodding.bplaced.net
-- OldtimerFL
-- sorgt fr realistisches Ausklinken der Frontladerschaufel wie bei den alten Frontladern das so blich war.
-- V2: Bug nach Verkauf einer im ausgekippten Zustand befindlichen Gabel bzw. in selbigem Zustand abgehngten Gabel
-- wurde behoben.

-- V3: LS13 Ready, Ausklinken auch mglich wenn nicht der Traktor angewhlt ist.
-- V3: FS13 ready, works fine if tractor is not selected (since mostly the implement is selected for frontloader work)
-- Date of edit / Datum der nderung: 14/09/2013

-- V4: FS17 ready, functions fixed and all variables in OFL table now.
-- Date of edit: 19/07/2017

-- XML:
--	<!-- referencePoint for hook, jointIndex # attacher joint, maxHookDistance max. distance from referencePoint to count as hooked -->
--	<OldtimerFrontloader referencePoint="0>34|0|4" jointIndex="5" maxHookDistance="0.1" />
	
	
OldtimerFL = {};

function OldtimerFL.prerequisitesPresent(specializations)
    return true;
end;

function OldtimerFL:load(xmlFile)
    self.setFLState = OldtimerFL.setFLState;
	self.OFL = {};
	self.OFL.implementReference = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.OldtimerFrontloader#referencePoint"));
	self.OFL.maxHookDistance = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.OldtimerFrontloader#maxHookDistance"), 0.1);
	self.OFL.jointIndex = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.OldtimerFrontloader#jointIndex"), 4);
	
    self.OFL.isFixed = true;  
	self.OFL.checkDistance = false;
	self.OFL.debugPoints = false;
end;

function OldtimerFL:delete()
end;

function OldtimerFL:readStream(streamId, connection)  
     self:setFLState(streamReadBool(streamId), true);  
end;
function OldtimerFL:writeStream(streamId, connection)  
    streamWriteBool(streamId, self.OFL.isFixed);  
end;

function OldtimerFL:mouseEvent(posX, posY, isDown, isUp, button)
end;
function OldtimerFL:keyEvent(unicode, sym, modifier, isDown)   
end;

function OldtimerFL:setFLState(state, noEventSend)  
    setFLstateEvent.sendEvent(self, state, noEventSend);	
    self.OFL.isFixed = state; 
end;

function OldtimerFL:update(dt)
    if self:getIsActive() and self.isEntered then  -- change from self:getIsActiveForInput() for FS13, so it works if implement is selected
  		if InputBinding.hasEvent(InputBinding.FLAusklinken) then 
		   if self.OFL.isFixed == true then
		       self:setFLState(false);
		   end;
        end;		
    end; 
    if self:getIsActive() then
	    if self.OFL.flImplementReferencePoint ~= nil then
			if self.OFL.isFixed == true then
				setJointRotationLimit(self.attacherJoints[self.OFL.jointIndex].jointIndex, 2, true, 0, -0);		   
			elseif self.OFL.isFixed == false then
				setJointRotationLimit(self.attacherJoints[self.OFL.jointIndex].jointIndex, 2, false, Utils.degToRad(40), Utils.degToRad(-40));				 
				if self.OFL.checkDistance == false then
					local nearestDistance = 0.2;
					local px, py, pz = getWorldTranslation(self.OFL.implementReference);
					local vx, vy, vz = getWorldTranslation(self.OFL.flImplementReferencePoint);
					if self.OFL.debugPoints then
						drawDebugPoint(px, py, pz, 1, 0, 0, 1);
						drawDebugPoint(vx, vy, vz, 0, 1, 0, 1);			
					end;
					local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
					if distance > nearestDistance then
						self.OFL.checkDistance = true;
					end;	
                end;				
		    end;	   
	        if self.OFL.checkDistance == true then
		        local nearestDistance = self.OFL.maxHookDistance;
	            local px, py, pz = getWorldTranslation(self.OFL.implementReference);
	            local vx, vy, vz = getWorldTranslation(self.OFL.flImplementReferencePoint);
				if self.OFL.debugPoints then
					drawDebugPoint(px, py, pz, 1, 0, 1, 1);
					drawDebugPoint(vx, vy, vz, 1, 1, 0, 1);					
				end;
	            local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
				if distance < nearestDistance then
					self:setFLState(true);
					self.OFL.checkDistance = false;
				end;	
			end;
		end;
	end;			
end;

function OldtimerFL:onDetachImplement(implementIndex)
	local implement = self.attachedImplements[implementIndex]
	local jointType = implement.object.attacherJoint.jointType;
	if jointType == AttacherJoints.JOINTTYPE_FRONTLOADER then
		self.OFL.flImplementReferencePoint = nil;
	end;
end;

function OldtimerFL:onAttachImplement(implement)
	local attacherJoint = self.attacherJoints[implement.jointDescIndex]
	if attacherJoint.jointType == AttacherJoints.JOINTTYPE_FRONTLOADER then
		if implement.object.OFLreferencePoint ~= nil then
		   self.OFL.flImplementReferencePoint = implement.object.OFLreferencePoint;
		end;
	end;	
end;

function OldtimerFL:detachImplement(implementIndex)
	local implement = self.attachedImplements[implementIndex]
	local jointType = implement.object.attacherJoint.jointType;
	if jointType == AttacherJoints.JOINTTYPE_FRONTLOADER then
		self.OFL.flImplementReferencePoint = nil;
	end;
end;

function OldtimerFL:attachImplement(implement)		
	local jointType = implement.object.attacherJoint.jointType;
	if jointType == AttacherJoints.JOINTTYPE_FRONTLOADER then
		if implement.object.OFLreferencePoint ~= nil then
		   self.OFL.flImplementReferencePoint = implement.object.OFLreferencePoint;
		end;
	end;
end;
function OldtimerFL:draw()
      g_currentMission:addHelpButtonText(g_i18n:getText("FLAusklinken"), InputBinding.FLAusklinken);
end;
function OldtimerFL:onLeave()
end;


setFLstateEvent = {};
setFLstateEvent_mt = Class(setFLstateEvent, Event);
InitEventClass(setFLstateEvent, "setFLstateEvent");

function setFLstateEvent:emptyNew()  
    local self = Event:new(setFLstateEvent_mt );
    self.className="setFLstateEvent";
    return self;
end;
function setFLstateEvent:new(vehicle, state) 
    self.vehicle = vehicle;
    self.state = state;
    return self;
end;
function setFLstateEvent:readStream(streamId, connection)  
    local id = streamReadInt32(streamId); 
    self.state = streamReadBool(streamId); 
    self.vehicle = networkGetObject(id); 
    self:run(connection);  
end;
function setFLstateEvent:writeStream(streamId, connection)   
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));	
    streamWriteBool(streamId, self.state );   
end;
function setFLstateEvent:run(connection) 
    self.vehicle:setFLState(self.state, true);
	if not connection:getIsServer() then  
		g_server:broadcastEvent(setFLstateEvent:new(self.vehicle, self.state), nil, connection, self.object);
	end;
end;
function setFLstateEvent.sendEvent(vehicle, state, noEventSend)  
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then   
			g_server:broadcastEvent(setFLstateEvent:new(vehicle, state), nil, nil, vehicle);
		else 
			g_client:getServerConnection():sendEvent(setFLstateEvent:new(vehicle, state));
		end;
	end;
end;